Subject: Re: bug#75585: 30.0.92; eww does not use proper file names for downloaded webpages
From: Eli Zaretskii <[email-masked]>
To: Anush V <[email-masked]>
Cc: [email-masked]
Date: Sat, 18 Jan 2025 12:58:55 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

[Please use Reply All to reply, to keep the bug tracker CC'ed.]

> From: Anush V <[email-masked]>
> Date: Fri, 17 Jan 2025 09:40:12 -0500
> 
> > From: Eli Zaretskii <[email-masked]>
> > Date: Thu, 16 Jan 2025 17:39:33 +0200
> >
> >> From: Anush V <[email-masked]>
> >> Date: Wed, 15 Jan 2025 09:57:25 -0500
> >>
> >> Hello Maintainers,
> >>
> >> I believe eww is not using proper names for downloaded webpages.
> >>
> >> Expected Behavior: Downloaded webpages should have a filename
> >> reflecting the full url with an .html extension.
> >
> > That's not what eww-download does.  It downloads the pages to the
> > directory specified by eww-download-directory, by default
> > "~/Downloads".
> 
> Thank you for clarifying.
> 
> >> 1. When I download the page https://www.gnu.org/, eww downloads the
> >> file without an .html extension, naming it simply as !.
> >
> > This page has no name.  We invent some name, in this case "!".  Apart
> > of documenting this, why is that a problem?
> 
> Yes documenting this should help.
> 
> >> 2. When I download https://www.gnu.org/home.html, eww names the file
> >> 'home.html'. While the extension is correct, shouldn't the filename
> >> reflect the full URL to avoid conflicts when downloading 'home.html'
> >> from different sites?
> >
> > eww-download detects conflicts and makes the downloaded name unique,
> > see eww-make-unique-file-name.  This seems to be a deliberate design
> > decision, and I can't say it sounds wrong to me.
> 
> Sure, I wasn't clear about how eww-download works.
> 
> > So, given that we augment the documentation to make these aspects
> > clear, do you still think there's a bug here?
> 
> Just adding to the documentation should be sufficient.

OK, so I've now done that, and I'm therefore closing this bug.

> My usecase was to download interesting webpages (from different
> websites) for reading offline.  I came across eww-download (Downloads
> URL) and eww-open-file (renders html file only if file has .html
> extension).  I thought I could download using eww-download and then
> read offline using eww-open-file

You can do that: eww-download shows the actual file name under which
it saved the Web page in the echo area.